Index: drivers/dahdi/dahdi-base.c
===================================================================
--- drivers/dahdi/dahdi-base.c	(revision 7107)
+++ drivers/dahdi/dahdi-base.c	(working copy)
@@ -4942,7 +5362,7 @@
 		if (data) {
 			/* Use specific ring cadence */
 			if (copy_from_user(&stack.cad, (struct dahdi_ring_cadence *)data, sizeof(stack.cad)))
-				return -EFAULT;
+				return _RETVAL(EFAULT);
 			memcpy(chan->ringcadence, &stack.cad, sizeof(chan->ringcadence));
 			chan->firstcadencepos = 0;
 			/* Looking for negative ringing time indicating where to loop back into ringcadence */
@@ -4975,11 +5395,11 @@
 		break;
 	default:
 		/* Check for common ioctl's and private ones */
-		rv = dahdi_common_ioctl(inode, file, cmd, data, unit);
+		rv = dahdi_common_ioctl(FOP_IOCTL_ARGS, unit);
 		/* if no span, just return with value */
 		if (!chan->span) return rv;
-		if ((rv == -ENOTTY) && chan->span->ioctl)
-			rv = chan->span->ioctl(chan, cmd, data);
+		if ((rv == _RETVAL(ENOTTY)) && chan->span->ioctl)
+			rv = chan->span->ioctl(chan, cmd, (u_long) data);
 		return rv;
 
 	}
@@ -5022,7 +5442,7 @@
 	unsigned long flags;
 
 	if (ecp->param_count > DAHDI_MAX_ECHOCANPARAMS)
-		return -E2BIG;
+		return _RETVAL(E2BIG);
 
 	if (ecp->tap_length == 0) {
 		/* disable mode, don't need to inspect params */
@@ -5036,21 +5456,26 @@
 			ec_state->ops->echocan_free(chan, ec_state);
 			release_echocan(ec_current);
 		}
-
 		return 0;
 	}
 
 	params = kmalloc(sizeof(params[0]) * DAHDI_MAX_ECHOCANPARAMS, GFP_KERNEL);
-
 	if (!params)
-		return -ENOMEM;
+		return _RETVAL(ENOMEM);
 
 	/* enable mode, need the params */
-
-	if (copy_from_user(params, (struct dahdi_echocanparam *) data, sizeof(params[0]) * ecp->param_count)) {
-		ret = -EFAULT;
+	if (ecp->param_count != 0) {
+#if defined(__FreeBSD__)
+		bcopy(data, &data, sizeof(void *));
+		if (copyin(data, params, sizeof(params[0]) * ecp->param_count)) {
+#else
+		if (copy_from_user(params, (struct dahdi_echocanparam *) data,
+			   sizeof(params[0]) * ecp->param_count)) {
+#endif
+			ret = _RETVAL(EFAULT);
 		goto exit_with_free;
 	}
+	}
 
 	/* free any echocan that may be on the channel already */
 	spin_lock_irqsave(&chan->lock, flags);
@@ -5076,7 +5501,7 @@
 		ecp->tap_length = deftaps;
 	}
 
-	ret = -ENODEV;
+	ret = _RETVAL(ENODEV);
 	ec_current = NULL;
 
 	/* attempt to use the span's echo canceler; fall back to built-in
@@ -5084,13 +5509,15 @@
 	if (chan->span && chan->span->echocan_create)
 		ret = chan->span->echocan_create(chan, ecp, params, &ec);
 
-	if ((ret == -ENODEV) && chan->ec_factory) {
+	if ((ret == _RETVAL(ENODEV)) && chan->ec_factory) {
 		/* try to get another reference to the module providing
 		   this channel's echo canceler */
+#if !defined(__FreeBSD__)
 		if (!try_module_get(chan->ec_factory->owner)) {
 			module_printk(KERN_ERR, "Cannot get a reference to the '%s' echo canceler\n", chan->ec_factory->name);
 			goto exit_with_free;
 		}
+#endif
 
 		/* got the reference, copy the pointer and use it for making
 		   an echo canceler instance if possible */
@@ -5099,14 +5526,13 @@
 		ret = ec_current->echocan_create(chan, ecp, params, &ec);
 		if (ret) {
 			release_echocan(ec_current);
-
 			goto exit_with_free;
 		}
 		if (!ec) {
 			module_printk(KERN_ERR, "%s failed to allocate an " \
 				      "dahdi_echocan_state instance.\n",
 				      ec_current->name);
-			ret = -EFAULT;
+			ret = _RETVAL(EFAULT);
 			goto exit_with_free;
 		}
 	}
@@ -5181,7 +5607,7 @@
 	}
 }
 
-static int dahdi_chan_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long data, int unit)
+static int dahdi_chan_ioctl(FOP_IOCTL_ARGS_DECL, int unit)
 {
 	struct dahdi_chan *chan = chans[unit];
 	unsigned long flags;
@@ -5189,12 +5615,34 @@
 	int ret;
 	int oldconf;
 	void *rxgain=NULL;
+#if !defined(__FreeBSD__)
+	int fflag = file->f_flags;
+#endif
 
 	WARN_ON(!chan->master);
 	if (!chan)
-		return -ENOSYS;
+		return _RETVAL(ENOSYS);
 
 	switch(cmd) {
+#if defined(__FreeBSD__)
+	case F_SETFL: {
+		int fflags = dahdi_get_flags(file);
+
+		get_user(j, data);
+		printf("F_SETFL: 0x%x\n", j);
+
+		/*
+		 * XXX: On the moment we're interested only in O_NONBLOCK
+		 * Need any other flags?
+		 */
+		if ((j & O_NONBLOCK) != 0) {
+			dahdi_set_flags(file, fflags | O_NONBLOCK);
+		} else {
+			dahdi_set_flags(file, fflags & ~O_NONBLOCK);
+		}
+		break;
+	}
+#endif
 	case DAHDI_SETSIGFREEZE:
 		get_user(j, (int *)data);
 		spin_lock_irqsave(&chan->lock, flags);
@@ -5216,7 +5664,7 @@
 		break;
 	case DAHDI_AUDIOMODE:
 		/* Only literal clear channels can be put in  */
-		if (chan->sig != DAHDI_SIG_CLEAR) return (-EINVAL);
+		if (chan->sig != DAHDI_SIG_CLEAR) return (_RETVAL(EINVAL));
 		get_user(j, (int *)data);
 		if (j) {
 			spin_lock_irqsave(&chan->lock, flags);
@@ -5272,7 +5720,7 @@
 		break;
 	case DAHDI_HDLCPPP:
 #ifdef CONFIG_DAHDI_PPP
-		if (chan->sig != DAHDI_SIG_CLEAR) return (-EINVAL);
+		if (chan->sig != DAHDI_SIG_CLEAR) return (_RETVAL(EINVAL));
 		get_user(j, (int *)data);
 		if (j) {
 			if (!chan->ppp) {
@@ -5318,7 +5766,7 @@
 						release_echocan(ec_current);
 					}
 				} else
-					return -ENOMEM;
+					return _RETVAL(ENOMEM);
 			}
 		} else {
 			chan->flags &= ~(DAHDI_FLAG_PPP | DAHDI_FLAG_HDLC | DAHDI_FLAG_FCS);
@@ -5333,11 +5781,11 @@
 		}
 #else
 		module_printk(KERN_NOTICE, "PPP support not compiled in\n");
-		return -ENOSYS;
+		return _RETVAL(ENOSYS);
 #endif
 		break;
 	case DAHDI_HDLCRAWMODE:
-		if (chan->sig != DAHDI_SIG_CLEAR)	return (-EINVAL);
+		if (chan->sig != DAHDI_SIG_CLEAR)	return (_RETVAL(EINVAL));
 		get_user(j, (int *)data);
 		chan->flags &= ~(DAHDI_FLAG_AUDIO | DAHDI_FLAG_HDLC | DAHDI_FLAG_FCS);
 		if (j) {
@@ -5347,7 +5795,7 @@
 		}
 		break;
 	case DAHDI_HDLCFCSMODE:
-		if (chan->sig != DAHDI_SIG_CLEAR)	return (-EINVAL);
+		if (chan->sig != DAHDI_SIG_CLEAR)	return (_RETVAL(EINVAL));
 		get_user(j, (int *)data);
 		chan->flags &= ~(DAHDI_FLAG_AUDIO | DAHDI_FLAG_HDLC | DAHDI_FLAG_FCS);
 		if (j) {
@@ -5372,9 +5820,9 @@
 		struct dahdi_echocanparams ecp;
 
 		if (!(chan->flags & DAHDI_FLAG_AUDIO))
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		if (copy_from_user(&ecp, (struct dahdi_echocanparams *) data, sizeof(ecp)))
-			return -EFAULT;
+			return _RETVAL(EFAULT);
 		data += sizeof(ecp);
 		if ((ret = ioctl_echocancel(chan, &ecp, (void *) data)))
 			return ret;
@@ -5385,7 +5833,7 @@
 		struct dahdi_echocanparams ecp;
 
 		if (!(chan->flags & DAHDI_FLAG_AUDIO))
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		get_user(j, (int *) data);
 		ecp.tap_length = j;
 		ecp.param_count = 0;
@@ -5396,7 +5844,7 @@
 	case DAHDI_ECHOTRAIN:
 		get_user(j, (int *)data); /* get pre-training time from user */
 		if ((j < 0) || (j >= DAHDI_MAX_PRETRAINING))
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		j <<= 3;
 		spin_lock_irqsave(&chan->lock, flags);
 		if (chan->ec_state) {
@@ -5408,12 +5856,12 @@
 			spin_unlock_irqrestore(&chan->lock, flags);
 		} else {
 			spin_unlock_irqrestore(&chan->lock, flags);
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		}
 		break;
 	case DAHDI_ECHOCANCEL_FAX_MODE:
 		if (!chan->ec_state) {
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		} else {
 			get_user(j, (int *) data);
 			spin_lock_irqsave(&chan->lock, flags);
@@ -5423,7 +5871,7 @@
 		break;
 	case DAHDI_SETTXBITS:
 		if (chan->sig != DAHDI_SIG_CAS)
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		get_user(j,(int *)data);
 		dahdi_cas_setbits(chan, j);
 		break;
@@ -5442,9 +5890,9 @@
 	case DAHDI_HOOK:
 		get_user(j,(int *)data);
 		if (chan->flags & DAHDI_FLAG_CLEAR)
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		if (chan->sig == DAHDI_SIG_CAS)
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		/* if no span, just do nothing */
 		if (!chan->span) return(0);
 		spin_lock_irqsave(&chan->lock, flags);
@@ -5467,7 +5915,7 @@
 				if ((chan->txstate == DAHDI_TXSTATE_KEWL) ||
 				  (chan->txstate == DAHDI_TXSTATE_AFTERKEWL)) {
 					spin_unlock_irqrestore(&chan->lock, flags);
-					return -EBUSY;
+					return _RETVAL(EBUSY);
 				}
 				dahdi_rbs_sethook(chan, DAHDI_TXSIG_OFFHOOK, DAHDI_TXSTATE_DEBOUNCE, chan->debouncetime);
 				spin_unlock_irqrestore(&chan->lock, flags);
@@ -5478,11 +5926,11 @@
 				if (!chan->curzone) {
 					spin_unlock_irqrestore(&chan->lock, flags);
 					module_printk(KERN_WARNING, "Cannot start tone until a tone zone is loaded.\n");
-					return -ENODATA;
+					return _RETVAL(ENODATA);
 				}
 				if (chan->txstate != DAHDI_TXSTATE_ONHOOK) {
 					spin_unlock_irqrestore(&chan->lock, flags);
-					return -EBUSY;
+					return _RETVAL(EBUSY);
 				}
 				if (chan->sig & __DAHDI_SIG_FXO) {
 					ret = 0;
@@ -5492,23 +5940,25 @@
 				} else
 					dahdi_rbs_sethook(chan, DAHDI_TXSIG_START, DAHDI_TXSTATE_START, chan->starttime);
 				spin_unlock_irqrestore(&chan->lock, flags);
-				if (file->f_flags & O_NONBLOCK)
-					return -EINPROGRESS;
+				if (fflag & O_NONBLOCK)
+					return _RETVAL(EINPROGRESS);
 #if 0
 				rv = schluffen(&chan->txstateq);
 				if (rv) return rv;
+#else
+				rv = 0;
 #endif
 				break;
 			case DAHDI_WINK:
 				spin_lock_irqsave(&chan->lock, flags);
 				if (chan->txstate != DAHDI_TXSTATE_ONHOOK) {
 					spin_unlock_irqrestore(&chan->lock, flags);
-					return -EBUSY;
+					return _RETVAL(EBUSY);
 				}
 				dahdi_rbs_sethook(chan, DAHDI_TXSIG_ONHOOK, DAHDI_TXSTATE_PREWINK, chan->prewinktime);
 				spin_unlock_irqrestore(&chan->lock, flags);
-				if (file->f_flags & O_NONBLOCK)
-					return -EINPROGRESS;
+				if (fflag & O_NONBLOCK)
+					return _RETVAL(EINPROGRESS);
 				rv = schluffen(&chan->txstateq);
 				if (rv) return rv;
 				break;
@@ -5516,12 +5966,12 @@
 				spin_lock_irqsave(&chan->lock, flags);
 				if (chan->txstate != DAHDI_TXSTATE_OFFHOOK) {
 					spin_unlock_irqrestore(&chan->lock, flags);
-					return -EBUSY;
+					return _RETVAL(EBUSY);
 				}
 				dahdi_rbs_sethook(chan, DAHDI_TXSIG_OFFHOOK, DAHDI_TXSTATE_PREFLASH, chan->preflashtime);
 				spin_unlock_irqrestore(&chan->lock, flags);
-				if (file->f_flags & O_NONBLOCK)
-					return -EINPROGRESS;
+				if (fflag & O_NONBLOCK)
+					return _RETVAL(EINPROGRESS);
 				rv = schluffen(&chan->txstateq);
 				if (rv) return rv;
 				break;
@@ -5531,7 +5981,7 @@
 				spin_unlock_irqrestore(&chan->lock, flags);
 				break;
 			default:
-				return -EINVAL;
+				return _RETVAL(EINVAL);
 			}
 		} else if (chan->span->sethook) {
 			if (chan->txhooksig != j) {
@@ -5539,31 +5989,31 @@
 				chan->span->sethook(chan, j);
 			}
 		} else
-			return -ENOSYS;
+			return _RETVAL(ENOSYS);
 		break;
 #ifdef CONFIG_DAHDI_PPP
 	case PPPIOCGCHAN:
 		if (chan->flags & DAHDI_FLAG_PPP)
-			return put_user(ppp_channel_index(chan->ppp), (int *)data) ? -EFAULT : 0;
+			return put_user(ppp_channel_index(chan->ppp), (int *)data) ? _RETVAL(EFAULT) : 0;
 		else
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		break;
 	case PPPIOCGUNIT:
 		if (chan->flags & DAHDI_FLAG_PPP)
-			return put_user(ppp_unit_number(chan->ppp), (int *)data) ? -EFAULT : 0;
+			return put_user(ppp_unit_number(chan->ppp), (int *)data) ? _RETVAL(EFAULT) : 0;
 		else
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		break;
 #endif
 	default:
-		return dahdi_chanandpseudo_ioctl(inode, file, cmd, data, unit);
+		return dahdi_chanandpseudo_ioctl(FOP_IOCTL_ARGS, unit);
 	}
 	return 0;
 }
 
-static int dahdi_prechan_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long data, int unit)
+static int dahdi_prechan_ioctl(FOP_IOCTL_ARGS_DECL, int unit)
 {
-	struct dahdi_chan *chan = file->private_data;
+	struct dahdi_chan *chan = dahdi_get_private_data(file);
 	int channo;
 	int res;
 
@@ -5574,63 +6024,63 @@
 	case DAHDI_SPECIFY:
 		get_user(channo,(int *)data);
 		if (channo < 1)
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		if (channo > DAHDI_MAX_CHANNELS)
-			return -EINVAL;
-		res = dahdi_specchan_open(inode, file, channo);
+			return _RETVAL(EINVAL);
+		res = dahdi_specchan_open(FOP_ARGS, channo);
 		if (!res) {
 			/* Setup the pointer for future stuff */
 			chan = chans[channo];
-			file->private_data = chan;
+			dahdi_set_private_data(file, chan);
 			/* Return success */
 			return 0;
 		}
 		return res;
 	default:
-		return -ENOSYS;
+		return _RETVAL(ENOSYS);
 	}
 	return 0;
 }
 
-static int dahdi_ioctl(struct inode *inode, struct file *file, unsigned int cmd, unsigned long data)
+static int dahdi_ioctl(FOP_IOCTL_ARGS_DECL)
 {
 	int unit = UNIT(file);
 	struct dahdi_chan *chan;
 	struct dahdi_timer *timer;
 
 	if (!unit)
-		return dahdi_ctl_ioctl(inode, file, cmd, data);
+		return dahdi_ctl_ioctl(FOP_IOCTL_ARGS);
 
-	if (unit == 250) {
+	if (unit == DAHDI_MINOR_TRANSCODE) {
 		/* dahdi_transcode should have updated the file_operations on
 		 * this file object on open, so we shouldn't be here. */
 		WARN_ON(1);
-		return -EFAULT;
+		return _RETVAL(EFAULT);
 	}
 
-	if (unit == 253) {
-		timer = file->private_data;
+	if (unit == DAHDI_MINOR_TIMER) {
+		timer = dahdi_get_private_data(file);
 		if (timer)
-			return dahdi_timer_ioctl(inode, file, cmd, data, timer);
+			return dahdi_timer_ioctl(FOP_IOCTL_ARGS, timer);
 		else
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 	}
-	if (unit == 254) {
-		chan = file->private_data;
+	if (unit == DAHDI_MINOR_CHANNEL) {
+		chan = dahdi_get_private_data(file);
 		if (chan)
-			return dahdi_chan_ioctl(inode, file, cmd, data, chan->channo);
+			return dahdi_chan_ioctl(FOP_IOCTL_ARGS, chan->channo);
 		else
-			return dahdi_prechan_ioctl(inode, file, cmd, data, unit);
+			return dahdi_prechan_ioctl(FOP_IOCTL_ARGS, unit);
 	}
-	if (unit == 255) {
-		chan = file->private_data;
+	if (unit == DAHDI_MINOR_PSEUDO) {
+		chan = dahdi_get_private_data(file);
 		if (!chan) {
 			module_printk(KERN_NOTICE, "No pseudo channel structure to read?\n");
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		}
-		return dahdi_chanandpseudo_ioctl(inode, file, cmd, data, chan->channo);
+		return dahdi_chanandpseudo_ioctl(FOP_IOCTL_ARGS, chan->channo);
 	}
-	return dahdi_chan_ioctl(inode, file, cmd, data, unit);
+	return dahdi_chan_ioctl(FOP_IOCTL_ARGS, unit);
 }
 
 int dahdi_register(struct dahdi_span *span, int prefmaster)
@@ -5638,19 +6088,21 @@
 	int x;
 
 	if (!span)
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
+#if !defined(__FreeBSD__)
 	WARN_ON(!span->owner);
+#endif
 
 	if (test_bit(DAHDI_FLAGBIT_REGISTERED, &span->flags)) {
 		module_printk(KERN_ERR, "Span %s already appears to be registered\n", span->name);
-		return -EBUSY;
+		return _RETVAL(EBUSY);
 	}
 
 	for (x = 1; x < maxspans; x++) {
 		if (spans[x] == span) {
 			module_printk(KERN_ERR, "Span %s already in list\n", span->name);
-			return -EBUSY;
+			return _RETVAL(EBUSY);
 		}
 	}
 
@@ -5665,7 +6117,7 @@
 			maxspans = x + 1;
 	} else {
 		module_printk(KERN_ERR, "Too many DAHDI spans registered\n");
-		return -EBUSY;
+		return _RETVAL(EBUSY);
 	}
 
 	set_bit(DAHDI_FLAGBIT_REGISTERED, &span->flags);
@@ -5695,11 +6147,19 @@
 
 	for (x = 0; x < span->channels; x++) {
 		if (span->chans[x]->channo < 250) {
+#if defined(__FreeBSD__)
+			span->chans[x]->file = make_dev(
+			    &dahdi_devsw, span->chans[x]->channo,
+			    UID_ROOT, GID_WHEEL, 0644,
+			    "dahdi/%d", span->chans[x]->channo);
+			dev_depends(dev_ctl, span->chans[x]->file);
+#else
 			char chan_name[32];
 			snprintf(chan_name, sizeof(chan_name), "dahdi!%d", 
 					span->chans[x]->channo);
 			CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, 
 					span->chans[x]->channo), NULL, chan_name);
+#endif
 		}
 	}
 
@@ -5750,9 +6210,17 @@
 #endif /* CONFIG_PROC_FS */
 
 	for (x = 0; x < span->channels; x++) {
-		if (span->chans[x]->channo < 250)
+		if (span->chans[x]->channo < 250) {
+#if defined(__FreeBSD__)
+			if (span->chans[x]->file != NULL) {
+				destroy_dev(span->chans[x]->file);
+				span->chans[x]->file = NULL;
+			}
+#else
 			CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, span->chans[x]->channo));
+#endif
 	}
+	}
 
 	spans[span->spanno] = NULL;
 	span->spanno = 0;
@@ -5777,6 +6245,7 @@
 				      (new_master)? new_master->name: "no master");
 	master = new_master;
 
+	spin_lock_destroy(&span->lock);
 	return 0;
 }
 
@@ -6261,7 +6730,11 @@
 out in the later versions, and is put back now. */
 				if (!(ms->flags & (DAHDI_FLAG_NETDEV | DAHDI_FLAG_PPP))) {
 					wake_up_interruptible(&ms->writebufq);
+#if defined(__FreeBSD__)
+					taskqueue_enqueue_fast(taskqueue_fast, &ms->selwakeup_task);
+#else
 					wake_up_interruptible(&ms->sel);
+#endif
 					if (ms->iomask & DAHDI_IOMUX_WRITE)
 						wake_up_interruptible(&ms->eventbufq);
 				}
@@ -6426,7 +6899,7 @@
 	case DAHDI_TXSTATE_WINK:
 		/* Wink complete, go on hook and stabalize */
 		dahdi_rbs_sethook(chan, DAHDI_TXSIG_ONHOOK, DAHDI_TXSTATE_ONHOOK, 0);
-		if (chan->file && (chan->file->f_flags & O_NONBLOCK))
+		if (dahdi_get_flags(chan->file) & O_NONBLOCK)
 			__qevent(chan, DAHDI_EVENT_HOOKCOMPLETE);
 		wake_up_interruptible(&chan->txstateq);
 		break;
@@ -6438,7 +6911,7 @@
 
 	case DAHDI_TXSTATE_FLASH:
 		dahdi_rbs_sethook(chan, DAHDI_TXSIG_OFFHOOK, DAHDI_TXSTATE_OFFHOOK, 0);
-		if (chan->file && (chan->file->f_flags & O_NONBLOCK))
+		if (dahdi_get_flags(chan->file) & O_NONBLOCK)
 			__qevent(chan, DAHDI_EVENT_HOOKCOMPLETE);
 		wake_up_interruptible(&chan->txstateq);
 		break;
@@ -6453,14 +6926,14 @@
 
 	case DAHDI_TXSTATE_AFTERSTART:
 		dahdi_rbs_sethook(chan, DAHDI_TXSIG_OFFHOOK, DAHDI_TXSTATE_OFFHOOK, 0);
-		if (chan->file && (chan->file->f_flags & O_NONBLOCK))
+		if (dahdi_get_flags(chan->file) & O_NONBLOCK)
 			__qevent(chan, DAHDI_EVENT_HOOKCOMPLETE);
 		wake_up_interruptible(&chan->txstateq);
 		break;
 
 	case DAHDI_TXSTATE_KEWL:
 		dahdi_rbs_sethook(chan, DAHDI_TXSIG_ONHOOK, DAHDI_TXSTATE_AFTERKEWL, DAHDI_AFTERKEWLTIME);
-		if (chan->file && (chan->file->f_flags & O_NONBLOCK))
+		if (dahdi_get_flags(chan->file) & O_NONBLOCK)
 			__qevent(chan, DAHDI_EVENT_HOOKCOMPLETE);
 		wake_up_interruptible(&chan->txstateq);
 		break;
@@ -6746,7 +7219,7 @@
 {
 	union dahdi_echocan_events events = chan->ec_state->events;
 
-	if (events.CED_tx_detected) {
+	if (events.e.CED_tx_detected) {
 		dahdi_qevent_nolock(chan, DAHDI_EVENT_TX_CED_DETECTED);
 		if (chan->ec_state) {
 			if (chan->ec_state->status.mode == ECHO_MODE_ACTIVE)
@@ -6756,7 +7229,7 @@
 		}
 	}
 
-	if (events.CED_rx_detected) {
+	if (events.e.CED_rx_detected) {
 		dahdi_qevent_nolock(chan, DAHDI_EVENT_RX_CED_DETECTED);
 		if (chan->ec_state) {
 			if (chan->ec_state->status.mode == ECHO_MODE_ACTIVE)
@@ -6766,18 +7239,18 @@
 		}
 	}
 
-	if (events.CNG_tx_detected)
+	if (events.e.CNG_tx_detected)
 		dahdi_qevent_nolock(chan, DAHDI_EVENT_TX_CNG_DETECTED);
 
-	if (events.CNG_rx_detected)
+	if (events.e.CNG_rx_detected)
 		dahdi_qevent_nolock(chan, DAHDI_EVENT_RX_CNG_DETECTED);
 
-	if (events.NLP_auto_disabled) {
+	if (events.e.NLP_auto_disabled) {
 		dahdi_qevent_nolock(chan, DAHDI_EVENT_EC_NLP_DISABLED);
 		chan->ec_state->status.mode = ECHO_MODE_FAX;
 	}
 
-	if (events.NLP_auto_enabled) {
+	if (events.e.NLP_auto_enabled) {
 		dahdi_qevent_nolock(chan, DAHDI_EVENT_EC_NLP_ENABLED);
 		chan->ec_state->status.mode = ECHO_MODE_ACTIVE;
 	}
@@ -7356,7 +7829,11 @@
 							/* if there are processes waiting in poll() on this channel,
 							   wake them up */
 							if (!ms->rxdisable) {
+#if defined(__FreeBSD__)
+								taskqueue_enqueue_fast(taskqueue_fast, &ms->selwakeup_task);
+#else
 								wake_up_interruptible(&ms->sel);
+#endif
 							}
 						}
 /* In the very orignal driver, it was quite well known to me (Jim) that there
@@ -7554,7 +8031,11 @@
 
 	if (!ss->rxdisable) {
 		wake_up_interruptible(&ss->readbufq);
+#if defined(__FreeBSD__)
+		taskqueue_enqueue_fast(taskqueue_fast, &ss->selwakeup_task);
+#else
 		wake_up_interruptible(&ss->sel);
+#endif
 		if (ss->iomask & DAHDI_IOMUX_READ)
 			wake_up_interruptible(&ss->eventbufq);
 	}
@@ -7606,7 +8087,11 @@
 
 			if (!(ss->flags & (DAHDI_FLAG_NETDEV | DAHDI_FLAG_PPP))) {
 				wake_up_interruptible(&ss->writebufq);
+#if defined(__FreeBSD__)
+				taskqueue_enqueue_fast(taskqueue_fast, &ss->selwakeup_task);
+#else
 				wake_up_interruptible(&ss->sel);
+#endif
 				if ((ss->iomask & DAHDI_IOMUX_WRITE) && (res >= 0))
 					wake_up_interruptible(&ss->eventbufq);
 			}
@@ -7634,7 +8119,11 @@
 			if (cur->pos <= 0) {
 				cur->tripped++;
 				cur->pos = cur->ms;
+#if defined(__FreeBSD__)
+				taskqueue_enqueue_fast(taskqueue_fast, &cur->selwakeup_task);
+#else
 				wake_up_interruptible(&cur->sel);
+#endif
 			}
 		}
 	}
@@ -7642,34 +8131,56 @@
 	spin_unlock_irqrestore(&zaptimerlock, flags);
 }
 
-static unsigned int dahdi_timer_poll(struct file *file, struct poll_table_struct *wait_table)
+static int dahdi_timer_poll(FOP_POLL_ARGS_DECL)
 {
-	struct dahdi_timer *timer = file->private_data;
+	struct dahdi_timer *timer = dahdi_get_private_data(file);
 	unsigned long flags;
 	int ret = 0;
-	if (timer) {
+
+	if (!timer) {
+#if defined(__FreeBSD__)
+		return (0);
+#else
+		return _RETVAL(EINVAL);
+#endif
+	}
+
+#if !defined(__FreeBSD__)
 		poll_wait(file, &timer->sel, wait_table);
+#endif
 		spin_lock_irqsave(&zaptimerlock, flags);
 		if (timer->tripped || timer->ping)
 			ret |= POLLPRI;
 		spin_unlock_irqrestore(&zaptimerlock, flags);
-	} else
-		ret = -EINVAL;
-	return ret;
+#if defined(__FreeBSD__)
+	if ((ret & events) == 0)
+		selrecord(td, &timer->sel);
+	return (ret & events);
+#else
+	return (ret);
+#endif
 }
 
 /* device poll routine */
-static unsigned int
-dahdi_chan_poll(struct file *file, struct poll_table_struct *wait_table, int unit)
+static int
+dahdi_chan_poll(FOP_POLL_ARGS_DECL, int unit)
 {
-
 	struct dahdi_chan *chan = chans[unit];
 	int	ret;
 	unsigned long flags;
 
 	  /* do the poll wait */
-	if (chan) {
+	if (!chan) {
+#if defined(__FreeBSD__)
+		return (0);
+#else
+		ret = _RETVAL(EINVAL);
+#endif
+	}
+
+#if !defined(__FreeBSD__)
 		poll_wait(file, &chan->sel, wait_table);
+#endif
 		ret = 0; /* start with nothing to return */
 		spin_lock_irqsave(&chan->lock, flags);
 		   /* if at least 1 write buffer avail */
@@ -7679,54 +8190,65 @@
 		if ((chan->outreadbuf > -1) && !chan->rxdisable) {
 			ret |= POLLIN | POLLRDNORM;
 		}
-		if (chan->eventoutidx != chan->eventinidx)
-		   {
+	if (chan->eventoutidx != chan->eventinidx) {
 			/* Indicate an exception */
 			ret |= POLLPRI;
 		   }
 		spin_unlock_irqrestore(&chan->lock, flags);
-	} else
-		ret = -EINVAL;
+
+#if defined(__FreeBSD__)
+	if ((ret & events) == 0)
+		selrecord(td, &chan->sel);
+	return (ret & events);
+#else
 	return(ret);  /* return what we found */
+#endif
 }
 
-static int dahdi_mmap(struct file *file, struct vm_area_struct *vm)
+static int dahdi_mmap(FOP_MMAP_ARGS_DECL)
 {
+#if !defined(__FreeBSD__)
 	int unit = UNIT(file);
-	if (unit == 250)
+	if (unit == DAHDI_MINOR_TRANSCODE)
 		return dahdi_transcode_fops->mmap(file, vm);
-	return -ENOSYS;
+#endif
+	return _RETVAL(ENOSYS);
 }
 
-static unsigned int dahdi_poll(struct file *file, struct poll_table_struct *wait_table)
+static poll_retval_t dahdi_poll(FOP_POLL_ARGS_DECL)
 {
 	int unit = UNIT(file);
 	struct dahdi_chan *chan;
 
 	if (!unit)
-		return -EINVAL;
+		return _RETVAL(EINVAL);
 
-	if (unit == 250)
-		return dahdi_transcode_fops->poll(file, wait_table);
+	if (unit == DAHDI_MINOR_TRANSCODE) {
+#if defined(__FreeBSD__)
+		return _RETVAL(ENXIO);
+#else
+		return dahdi_transcode_fops->poll(FOP_POLL_ARGS);
+#endif
+	}
 
-	if (unit == 253)
-		return dahdi_timer_poll(file, wait_table);
+	if (unit == DAHDI_MINOR_TIMER)
+		return dahdi_timer_poll(FOP_POLL_ARGS);
 
-	if (unit == 254) {
-		chan = file->private_data;
+	if (unit == DAHDI_MINOR_CHANNEL) {
+		chan = dahdi_get_private_data(file);
 		if (!chan)
-			return -EINVAL;
-		return dahdi_chan_poll(file, wait_table,chan->channo);
+			return _RETVAL(EINVAL);
+		return dahdi_chan_poll(FOP_POLL_ARGS, chan->channo);
 	}
-	if (unit == 255) {
-		chan = file->private_data;
+	if (unit == DAHDI_MINOR_PSEUDO) {
+		chan = dahdi_get_private_data(file);
 		if (!chan) {
 			module_printk(KERN_NOTICE, "No pseudo channel structure to read?\n");
-			return -EINVAL;
+			return _RETVAL(EINVAL);
 		}
-		return dahdi_chan_poll(file, wait_table, chan->channo);
+		return dahdi_chan_poll(FOP_POLL_ARGS, chan->channo);
 	}
-	return dahdi_chan_poll(file, wait_table, unit);
+	return dahdi_chan_poll(FOP_POLL_ARGS, unit);
 }
 
 static void __dahdi_transmit_chunk(struct dahdi_chan *chan, unsigned char *buf)
@@ -8141,8 +8663,9 @@
 					do {
 						data[pos++] = span->chans[z]->readchunk[y];
 						if (pos == DAHDI_CHUNKSIZE) {
-							if(!(span->chans[x]->flags & DAHDI_FLAG_NOSTDTXRX))
+							if(!(span->chans[x]->flags & DAHDI_FLAG_NOSTDTXRX)) {
 								__dahdi_receive_chunk(span->chans[x], data);
+							}
 							pos = 0;
 						}
 						z=span->chans[z]->nextslave;
@@ -8150,9 +8673,10 @@
 				}
 			} else {
 				/* Process a normal channel */
-				if (!(span->chans[x]->flags & DAHDI_FLAG_NOSTDTXRX))
+				if (!(span->chans[x]->flags & DAHDI_FLAG_NOSTDTXRX)) {
 					__dahdi_real_receive(span->chans[x]);
 			}
+			}
 			if (span->chans[x]->itimer) {
 				span->chans[x]->itimer -= DAHDI_CHUNKSIZE;
 				if (span->chans[x]->itimer <= 0) {
@@ -8210,6 +8734,7 @@
 	return 0;
 }
 
+#if !defined(__FreeBSD__)
 MODULE_AUTHOR("Mark Spencer <markster@digium.com>");
 MODULE_DESCRIPTION("DAHDI Telephony Interface");
 MODULE_LICENSE("GPL v2");
@@ -8232,6 +8757,7 @@
 	.fsync   = NULL,
 	.fasync  = NULL,
 };
+#endif /* !__FreeBSD__ */
 
 #ifdef CONFIG_DAHDI_WATCHDOG
 static struct timer_list watchdogtimer;
@@ -8295,18 +8821,30 @@
 
 int dahdi_register_chardev(struct dahdi_chardev *dev)
 {
+#if defined(__FreeBSD__)
+	dev->dev = make_dev(&dahdi_devsw, dev->minor,
+	    UID_ROOT, GID_WHEEL, 0644,
+	    "dahdi/%s", dev->name);
+#else
 	char udevname[strlen(dev->name) + sizeof("dahdi!")];
 
 	strcpy(udevname, "dahdi!");
 	strcat(udevname, dev->name);
 	CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, dev->minor), NULL, udevname);
-
+#endif /* !__FreeBSD__ */
 	return 0;
 }
 
 int dahdi_unregister_chardev(struct dahdi_chardev *dev)
 {
+#if defined(__FreeBSD__)
+	if (dev->dev) {
+		destroy_dev(dev->dev);
+		dev->dev = NULL;
+	}
+#else
 	CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, dev->minor));
+#endif /* !__FreeBSD__ */
 
 	return 0;
 }
@@ -8314,21 +8852,38 @@
 static int __init dahdi_init(void)
 {
 	int res = 0;
+#if defined(__FreeBSD__)
+	struct cdev *dev;
+#endif
 
 #ifdef CONFIG_PROC_FS
 	proc_entries[0] = proc_mkdir("dahdi", NULL);
 #endif
 
+#if defined(__FreeBSD__)
+	dev_ctl = make_dev(&dahdi_devsw, DAHDI_MINOR_CTL,
+	    UID_ROOT, GID_WHEEL, 0644, "dahdi/ctl");
+	dev = make_dev(&dahdi_devsw, DAHDI_MINOR_TIMER,
+	    UID_ROOT, GID_WHEEL, 0644, "dahdi/timer");
+	dev_depends(dev_ctl, dev);
+	dev = make_dev(&dahdi_devsw, DAHDI_MINOR_CHANNEL,
+	    UID_ROOT, GID_WHEEL, 0644, "dahdi/channel");
+	dev_depends(dev_ctl, dev);
+	dev = make_dev(&dahdi_devsw, DAHDI_MINOR_PSEUDO,
+	    UID_ROOT, GID_WHEEL, 0644, "dahdi/pseudo");
+	dev_depends(dev_ctl, dev);
+#else /* !__FreeBSD__ */
 	if ((res = register_chrdev(DAHDI_MAJOR, "dahdi", &dahdi_fops))) {
 		module_printk(KERN_ERR, "Unable to register DAHDI character device handler on %d\n", DAHDI_MAJOR);
 		return res;
 	}
 
 	dahdi_class = class_create(THIS_MODULE, "dahdi");
-	CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, 253), NULL, "dahdi!timer");
-	CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, 254), NULL, "dahdi!channel");
-	CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, 255), NULL, "dahdi!pseudo");
-	CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, 0), NULL, "dahdi!ctl");
+	CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, DAHDI_MINOR_TIMER), NULL, "dahdi!timer");
+	CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, DAHDI_MINOR_CHANNEL), NULL, "dahdi!channel");
+	CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, DAHDI_MINOR_PSEUDO), NULL, "dahdi!pseudo");
+	CLASS_DEV_CREATE(dahdi_class, MKDEV(DAHDI_MAJOR, DAHDI_MINOR_CTL), NULL, "dahdi!ctl");
+#endif
 
 	module_printk(KERN_INFO, "Telephony Interface Registered on major %d\n", DAHDI_MAJOR);
 	module_printk(KERN_INFO, "Version: %s\n", DAHDI_VERSION);
@@ -8348,13 +8903,20 @@
 
 	coretimer_cleanup();
 
-	CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, 253)); /* timer */
-	CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, 254)); /* channel */
-	CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, 255)); /* pseudo */
-	CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, 0)); /* ctl */
+#if defined(__FreeBSD__)
+	if (dev_ctl != NULL) {
+		destroy_dev(dev_ctl);
+		dev_ctl = NULL;
+	}
+#else
+	CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, DAHDI_MINOR_TIMER)); /* timer */
+	CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, DAHDI_MINOR_CHANNEL)); /* channel */
+	CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, DAHDI_MINOR_PSEUDO)); /* pseudo */
+	CLASS_DEV_DESTROY(dahdi_class, MKDEV(DAHDI_MAJOR, DAHDI_MINOR_CTL)); /* ctl */
 	class_destroy(dahdi_class);
 
 	unregister_chrdev(DAHDI_MAJOR, "dahdi");
+#endif
 
 #ifdef CONFIG_PROC_FS
 	remove_proc_entry("dahdi", NULL);
@@ -8371,5 +8933,28 @@
 #endif
 }
 
+#if defined(__FreeBSD__)
+static int
+dahdi_modevent(module_t mod, int cmd, void *arg)
+{
+	switch (cmd) {
+	case MOD_LOAD:
+		return dahdi_init();
+
+	case MOD_UNLOAD:
+		dahdi_cleanup();
+		return 0;
+
+	default:
+		/* we only understand load/unload*/
+		return _RETVAL(EINVAL);
+	}
+}
+
+/* Now declare the module to the system */
+MODULE_VERSION(dahdi, 1);
+DEV_MODULE(dahdi, dahdi_modevent, NULL);
+#else /* !__FreeBSD__ */
 module_init(dahdi_init);
 module_exit(dahdi_cleanup);
+#endif /* !__FreeBSD__ */
